DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Private Member Functions | List of all members
DiMonoScaleTemplate< T > Class Template Reference

Template class to scale monochrome images (on pixel data level). More...

Inheritance diagram for DiMonoScaleTemplate< T >:

## Public Member Functions
| DiMonoScaleTemplate (const DiMonoPixel *pixel, const Uint16 columns, const Uint16 rows, const signed long left_pos, const signed long top_pos, const Uint16 src_cols, const Uint16 src_rows, const Uint16 dest_cols, const Uint16 dest_rows, const Uint32 frames, const int bits, const int interpolate, const Uint16 pvalue)
| constructor More...
virtual | ~DiMonoScaleTemplate ()
| destructor
Public Member Functions inherited from DiMonoPixelTemplate< T >
| DiMonoPixelTemplate (const unsigned long count)
| constructor More...
| DiMonoPixelTemplate (const DiInputPixel *pixel, DiMonoModality *modality)
| constructor More...
| DiMonoPixelTemplate (DiMonoOutputPixel *pixel, DiMonoModality *modality)
| constructor More...
virtual | ~DiMonoPixelTemplate ()
| destructor
EP_Representation | getRepresentation () const
| get integer representation More...
const void * | getData () const
| get pointer to internal pixel data More...
void * | getDataPtr ()
| get pointer to internal pixel data More...
void * | getDataArrayPtr ()
| get reference to pointer to internal pixel data. More...
int | getMinMaxValues (double &min, double &max) const
| get minimum and maximum pixel values More...
int | getMinMaxWindow (const int idx, double &center, double &width)
| get automatically computed min-max window More...
virtual int | getRoiWindow (const unsigned long left_pos, const unsigned long top_pos, const unsigned long width, const unsigned long height, const unsigned long columns, const unsigned long rows, const unsigned long frame, double &voiCenter, double &voiWidth)
| get automatically computed Region of Interest (ROI) window More...
int | getHistogramWindow (const double thresh, double &center, double &width)
| get automatically computed histogram window More...
Public Member Functions inherited from DiMonoPixel
| DiMonoPixel (const unsigned long count)
| constructor More...
| DiMonoPixel (const DiInputPixel *pixel, DiMonoModality *modality)
| constructor More...
| DiMonoPixel (DiMonoOutputPixel *pixel, DiMonoModality *modality)
| constructor More...
virtual | ~DiMonoPixel ()
| destructor
int | getPlanes () const
| get number of planes More...
unsigned int | getBits () const
| get number of bits per pixel More...
double | getAbsMinimum () const
| get absolute minimum pixel value. More...
double | getAbsMaximum () const
| get absolute maximum pixel value. More...
double | getAbsMaxRange () const
| get absolute pixel range More...
const char * | getModalityLutExplanation () const
| get modality LUT explanation string More...
DiMonoModality * | addReferenceToModality ()
| add a reference to the internally managed modality transform object More...
int | isPotentiallySigned () const
| check whether pixel data is 'potentially' signed. More...
Public Member Functions inherited from DiPixel
| DiPixel (const unsigned long count, const unsigned long inputCount=0)
| constructor More...
virtual | ~DiPixel ()
| destructor
unsigned long | getCount () const
| get number of pixels More...
unsigned long | getInputCount () const
| get number of pixels stored in the 'PixelData' element More...
Public Member Functions inherited from DiPixelRepresentationTemplate< T >
| DiPixelRepresentationTemplate ()
| default constructor
virtual | ~DiPixelRepresentationTemplate ()
| destructor
int | isSigned () const
| check whether template type T is signed or not More...

## Private Member Functions
void | scale (const T *pixel, const unsigned int bits, const int interpolate, const Uint16 pvalue)
| scale pixel data More...

## Additional Inherited Members
Protected Member Functions inherited from DiMonoPixelTemplate< T >
| DiMonoPixelTemplate (const DiPixel *pixel, DiMonoModality *modality)
| constructor More...
| DiMonoPixelTemplate (const DiMonoPixel *pixel, const unsigned long count)
| constructor More...
void | determineMinMax (T minvalue=0, T maxvalue=0, const int mode=0x1)
| determine minimum and maximum pixel values More...
Protected Member Functions inherited from DiMonoPixel
| DiMonoPixel (const DiPixel *pixel, DiMonoModality *modality)
| constructor More...
| DiMonoPixel (const DiMonoPixel *pixel, const unsigned long count)
| constructor More...
Protected Member Functions inherited from DiScaleTemplate< T >
| DiScaleTemplate (const int planes, const Uint16 columns, const Uint16 rows, const signed long left_pos, const signed long top_pos, const Uint16 src_cols, const Uint16 src_rows, const Uint16 dest_cols, const Uint16 dest_rows, const Uint32 frames, const int bits=0)
| constructor, scale clipping area. More...
| DiScaleTemplate (const int planes, const Uint16 src_cols, const Uint16 src_rows, const Uint16 dest_cols, const Uint16 dest_rows, const Uint32 frames, const int bits=0)
| constructor, scale whole image. More...
virtual | ~DiScaleTemplate ()
| destructor
int | isSigned () const
| check whether template type T is signed or not More...
void | scaleData (const T *src[], T *dest[], const int interpolate, const T value=0)
| choose scaling/clipping algorithm depending on specified parameters. More...
Protected Member Functions inherited from DiTransTemplate< T >
| DiTransTemplate (const int planes, const Uint16 src_x, const Uint16 src_y, const Uint16 dest_x, const Uint16 dest_y, const Uint32 frames, const int bits=0)
| constructor More...
virtual | ~DiTransTemplate ()
| destructor
void | copyPixel (const T *src[], T *dest[])
| copy pixel data More...
void | fillPixel (T *dest[], const T value)
| fill pixel data with specified value More...
void | clearPixel (T *dest[])
| clear pixel data (set values to 0) More...
Protected Attributes inherited from DiMonoPixelTemplate< T >
T * | Data
| pointer to pixel data
Protected Attributes inherited from DiMonoPixel
DiMonoModality * | Modality
| pointer to modality transform object
Protected Attributes inherited from DiPixel
unsigned long | Count
| number of pixels
unsigned long | InputCount
| number of pixels in the input buffer
Protected Attributes inherited from DiScaleTemplate< T >
const signed long | Left
| left coordinate of clipping area
const signed long | Top
| top coordinate of clipping area
const Uint16 | Columns
| width of source image
const Uint16 | Rows
| height of source image
Protected Attributes inherited from DiTransTemplate< T >
int | Planes
| number of planes
Uint16 | Src_X
| width of source image
Uint16 | Src_Y
| height of source image
const Uint16 | Dest_X
| width of destination image
const Uint16 | Dest_Y
| height of destination image
const Uint32 | Frames
| number of frames
const int | Bits
| number of bits per plane/pixel

## Detailed Description

### template<class T>
class DiMonoScaleTemplate< T >

Template class to scale monochrome images (on pixel data level).

## Constructor & Destructor Documentation

## ◆ DiMonoScaleTemplate()

template<class T >

DiMonoScaleTemplate< T >::DiMonoScaleTemplate | ( | const DiMonoPixel * | pixel,
|  | const Uint16 | columns,
|  | const Uint16 | rows,
|  | const signed long | left_pos,
|  | const signed long | top_pos,
|  | const Uint16 | src_cols,
|  | const Uint16 | src_rows,
|  | const Uint16 | dest_cols,
|  | const Uint16 | dest_rows,
|  | const Uint32 | frames,
|  | const int | bits,
|  | const int | interpolate,
|  | const Uint16 | pvalue
| ) |  |
| inline

constructor

Parameters

  pixel | pointer to intermediate pixel representation
  columns | width of source image
  rows | height of source image
  left_pos | left coordinate of clipping area
  top_pos | top coordinate of clipping area
  src_cols | width of clipping area
  src_rows | height of clipping area
  dest_cols | width of destination image (scaled image)
  dest_rows | height of destination image
  frames | number of frames
  bits | number of bits per plane/pixel
  interpolate | use of interpolation when scaling
  pvalue | value possibly used for regions outside the image boundaries

## Member Function Documentation

## ◆ scale()

template<class T >

void DiMonoScaleTemplate< T >::scale | ( | const T * | pixel,
|  | const unsigned int | bits,
|  | const int | interpolate,
|  | const Uint16 | pvalue
| ) |  |
| inline private

scale pixel data

Parameters

  pixel | pointer to pixel data to be scaled
  bits | bit depth of pixel data
  interpolate | use of interpolation when scaling
  pvalue | value possibly used for regions outside the image boundaries

References DiMonoPixelTemplate< T >::Data, and DiPixel::getCount().

The documentation for this class was generated from the following file:

- dcmimgle/include/dcmtk/dcmimgle/dimosct.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1